
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
 this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}


/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a<<8) | b)

static int make_pair(int i1, int i2)
{
  unsigned u1 = i1;
  unsigned u2 = i2;

  if ((u1 > 0xFFFF) || (u2 > 0xFFFF))
    cf_error( "Can't operate with value out of bounds in pair constructor");

  return (u1 << 16) | u2;
}

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

static void
finish_iface_config(struct ospf_iface_patt *ip)
{
  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

static struct static_route *this_srt;



/* Line 189 of yacc.c  */
#line 225 "cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     GEQ = 261,
     LEQ = 262,
     NEQ = 263,
     AND = 264,
     OR = 265,
     PO = 266,
     PC = 267,
     NUM = 268,
     ENUM = 269,
     RTRID = 270,
     IPA = 271,
     SYM = 272,
     TEXT = 273,
     PREFIX_DUMMY = 274,
     DEFINE = 275,
     ON = 276,
     OFF = 277,
     YES = 278,
     NO = 279,
     LOG = 280,
     SYSLOG = 281,
     ALL = 282,
     DEBUG = 283,
     TRACE = 284,
     INFO = 285,
     REMOTE = 286,
     WARNING = 287,
     ERROR = 288,
     AUTH = 289,
     FATAL = 290,
     BUG = 291,
     STDERR = 292,
     SOFT = 293,
     CONFIGURE = 294,
     DOWN = 295,
     KERNEL = 296,
     PERSIST = 297,
     SCAN = 298,
     TIME = 299,
     LEARN = 300,
     DEVICE = 301,
     ASYNC = 302,
     TABLE = 303,
     ROUTER = 304,
     ID = 305,
     PROTOCOL = 306,
     PREFERENCE = 307,
     DISABLED = 308,
     DIRECT = 309,
     INTERFACE = 310,
     IMPORT = 311,
     EXPORT = 312,
     FILTER = 313,
     NONE = 314,
     STATES = 315,
     ROUTES = 316,
     FILTERS = 317,
     PASSWORD = 318,
     FROM = 319,
     PASSIVE = 320,
     TO = 321,
     EVENTS = 322,
     PACKETS = 323,
     PROTOCOLS = 324,
     INTERFACES = 325,
     PRIMARY = 326,
     STATS = 327,
     COUNT = 328,
     FOR = 329,
     COMMANDS = 330,
     PREEXPORT = 331,
     GENERATE = 332,
     LISTEN = 333,
     BGP = 334,
     V6ONLY = 335,
     ADDRESS = 336,
     PORT = 337,
     PASSWORDS = 338,
     SHOW = 339,
     STATUS = 340,
     SUMMARY = 341,
     ROUTE = 342,
     SYMBOLS = 343,
     DUMP = 344,
     RESOURCES = 345,
     SOCKETS = 346,
     NEIGHBORS = 347,
     ATTRIBUTES = 348,
     ECHO = 349,
     DISABLE = 350,
     ENABLE = 351,
     RESTART = 352,
     FUNCTION = 353,
     PRINT = 354,
     PRINTN = 355,
     UNSET = 356,
     RETURN = 357,
     ACCEPT = 358,
     REJECT = 359,
     QUITBIRD = 360,
     INT = 361,
     BOOL = 362,
     IP = 363,
     PREFIX = 364,
     PAIR = 365,
     SET = 366,
     STRING = 367,
     BGPMASK = 368,
     BGPPATH = 369,
     CLIST = 370,
     IF = 371,
     THEN = 372,
     ELSE = 373,
     CASE = 374,
     TRUE = 375,
     FALSE = 376,
     GW = 377,
     NET = 378,
     MASK = 379,
     PROTO = 380,
     SOURCE = 381,
     SCOPE = 382,
     CAST = 383,
     DEST = 384,
     LEN = 385,
     DEFINED = 386,
     ADD = 387,
     DELETE = 388,
     CONTAINS = 389,
     RESET = 390,
     PREPEND = 391,
     FIRST = 392,
     LAST = 393,
     MATCH = 394,
     EMPTY = 395,
     WHERE = 396,
     EVAL = 397,
     LOCAL = 398,
     NEIGHBOR = 399,
     AS = 400,
     HOLD = 401,
     CONNECT = 402,
     RETRY = 403,
     KEEPALIVE = 404,
     MULTIHOP = 405,
     STARTUP = 406,
     VIA = 407,
     NEXT = 408,
     HOP = 409,
     SELF = 410,
     DEFAULT = 411,
     PATH = 412,
     METRIC = 413,
     START = 414,
     DELAY = 415,
     FORGET = 416,
     WAIT = 417,
     AFTER = 418,
     BGP_PATH = 419,
     BGP_LOCAL_PREF = 420,
     BGP_MED = 421,
     BGP_ORIGIN = 422,
     BGP_NEXT_HOP = 423,
     BGP_ATOMIC_AGGR = 424,
     BGP_AGGREGATOR = 425,
     BGP_COMMUNITY = 426,
     RR = 427,
     RS = 428,
     CLIENT = 429,
     CLUSTER = 430,
     AS4 = 431,
     ADVERTISE = 432,
     IPV4 = 433,
     CAPABILITIES = 434,
     LIMIT = 435,
     OSPF = 436,
     AREA = 437,
     OSPF_METRIC1 = 438,
     OSPF_METRIC2 = 439,
     OSPF_TAG = 440,
     BROADCAST = 441,
     RFC1583COMPAT = 442,
     STUB = 443,
     TICK = 444,
     COST = 445,
     RETRANSMIT = 446,
     HELLO = 447,
     TRANSMIT = 448,
     PRIORITY = 449,
     DEAD = 450,
     NONBROADCAST = 451,
     POINTOPOINT = 452,
     TYPE = 453,
     SIMPLE = 454,
     AUTHENTICATION = 455,
     STRICT = 456,
     CRYPTOGRAPHIC = 457,
     ELIGIBLE = 458,
     POLL = 459,
     NETWORKS = 460,
     HIDDEN = 461,
     VIRTUAL = 462,
     LINK = 463,
     RX = 464,
     BUFFER = 465,
     LARGE = 466,
     NORMAL = 467,
     STUBNET = 468,
     TOPOLOGY = 469,
     STATE = 470,
     PIPE = 471,
     PEER = 472,
     MODE = 473,
     OPAQUE = 474,
     TRANSPARENT = 475,
     RIP = 476,
     INFINITY = 477,
     PERIOD = 478,
     GARBAGE = 479,
     TIMEOUT = 480,
     MULTICAST = 481,
     QUIET = 482,
     NOLISTEN = 483,
     VERSION1 = 484,
     PLAINTEXT = 485,
     MD5 = 486,
     HONOR = 487,
     NEVER = 488,
     ALWAYS = 489,
     RIP_METRIC = 490,
     RIP_TAG = 491,
     STATIC = 492,
     DROP = 493,
     PROHIBIT = 494
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 146 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  void *g;
  bird_clock_t time;
  struct prefix px;



/* Line 214 of yacc.c  */
#line 522 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 534 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  42
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1544

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  261
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  180
/* YYNRULES -- Number of rules.  */
#define YYNRULES  546
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1017

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   494

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    30,     2,     2,     2,    29,     2,     2,
     251,   252,    27,    25,   257,    26,    24,    28,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   254,   253,
      21,    20,    22,   258,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   259,     2,   260,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   255,     2,   256,    23,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      51,    53,    55,    58,    61,    63,    65,    66,    71,    73,
      75,    77,    79,    83,    85,    89,    91,    93,    95,    97,
      99,   101,   103,   105,   107,   111,   116,   119,   120,   122,
     125,   128,   132,   135,   138,   142,   146,   150,   155,   157,
     159,   161,   166,   167,   170,   173,   176,   178,   181,   183,
     184,   186,   187,   190,   193,   196,   199,   202,   205,   209,
     212,   214,   216,   218,   220,   224,   228,   229,   231,   233,
     236,   237,   239,   243,   245,   249,   252,   256,   260,   264,
     265,   269,   271,   273,   277,   279,   283,   285,   287,   289,
     291,   293,   295,   300,   302,   303,   307,   312,   314,   317,
     318,   324,   330,   336,   342,   347,   351,   356,   362,   364,
     365,   369,   374,   379,   380,   383,   387,   391,   395,   398,
     401,   404,   408,   412,   415,   418,   420,   422,   427,   431,
     435,   439,   443,   447,   451,   455,   460,   462,   464,   466,
     467,   469,   473,   477,   481,   486,   488,   490,   492,   493,
     498,   501,   503,   505,   507,   509,   511,   513,   515,   517,
     519,   522,   525,   526,   530,   532,   536,   538,   540,   542,
     545,   549,   552,   557,   558,   564,   565,   568,   570,   574,
     580,   582,   584,   586,   588,   590,   592,   597,   599,   603,
     607,   609,   612,   615,   622,   624,   628,   629,   634,   638,
     640,   644,   648,   652,   655,   658,   661,   664,   665,   668,
     671,   672,   678,   680,   682,   684,   686,   688,   690,   694,
     698,   700,   702,   703,   708,   710,   712,   714,   716,   718,
     720,   722,   724,   726,   730,   734,   738,   742,   746,   750,
     754,   758,   762,   766,   770,   774,   778,   782,   785,   790,
     792,   794,   796,   798,   801,   804,   808,   812,   819,   823,
     827,   831,   835,   842,   849,   856,   861,   863,   865,   867,
     869,   871,   873,   875,   876,   878,   882,   884,   888,   889,
     891,   896,   903,   908,   912,   918,   924,   929,   936,   940,
     943,   949,   955,   964,   973,   982,   985,   989,   993,   999,
    1006,  1013,  1018,  1023,  1029,  1036,  1043,  1049,  1056,  1062,
    1068,  1074,  1080,  1086,  1093,  1100,  1109,  1116,  1122,  1127,
    1133,  1138,  1144,  1149,  1152,  1156,  1160,  1162,  1165,  1168,
    1171,  1175,  1178,  1179,  1183,  1187,  1190,  1195,  1198,  1201,
    1203,  1208,  1210,  1212,  1213,  1217,  1220,  1223,  1226,  1231,
    1233,  1234,  1238,  1239,  1242,  1245,  1249,  1252,  1255,  1259,
    1262,  1265,  1268,  1270,  1274,  1277,  1280,  1283,  1286,  1290,
    1293,  1296,  1299,  1303,  1306,  1309,  1312,  1316,  1319,  1324,
    1327,  1330,  1333,  1337,  1341,  1345,  1347,  1348,  1351,  1353,
    1355,  1358,  1362,  1363,  1366,  1368,  1370,  1373,  1377,  1378,
    1379,  1383,  1384,  1388,  1392,  1394,  1395,  1400,  1407,  1414,
    1421,  1428,  1431,  1435,  1439,  1445,  1450,  1455,  1458,  1462,
    1466,  1471,  1476,  1481,  1487,  1493,  1498,  1502,  1507,  1512,
    1517,  1522,  1524,  1526,  1528,  1530,  1532,  1534,  1536,  1538,
    1539,  1542,  1545,  1546,  1550,  1551,  1555,  1556,  1560,  1563,
    1567,  1571,  1575,  1578,  1582,  1586,  1589,  1592,  1595,  1600,
    1602,  1604,  1606,  1608,  1610,  1612,  1614,  1616,  1618,  1620,
    1622,  1624,  1626,  1628,  1630,  1632,  1634,  1636,  1638,  1640,
    1642,  1644,  1646,  1648,  1650,  1652,  1654,  1656,  1658,  1660,
    1662,  1664,  1666,  1668,  1670,  1672,  1674,  1676,  1678,  1681,
    1684,  1687,  1690,  1693,  1696,  1699,  1702,  1706,  1710,  1714,
    1718,  1722,  1726,  1730,  1732,  1734,  1736,  1738,  1740,  1742,
    1744,  1746,  1748,  1750,  1752,  1754,  1756
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     262,     0,    -1,   263,     3,    -1,     4,   436,    -1,    -1,
     263,   435,    -1,    13,    -1,   251,   376,   252,    -1,    17,
      -1,    31,    17,    20,   264,   253,    -1,    31,    17,    20,
      16,   253,    -1,   264,    -1,    32,    -1,    34,    -1,    33,
      -1,    35,    -1,    -1,    16,    -1,    17,    -1,   267,   270,
      -1,   268,    -1,   267,    -1,    28,   264,    -1,   254,   267,
      -1,    18,    -1,    18,    -1,    -1,    36,   274,   275,   253,
      -1,    18,    -1,    37,    -1,    48,    -1,    38,    -1,   255,
     276,   256,    -1,   277,    -1,   276,   257,   277,    -1,    39,
      -1,    40,    -1,    41,    -1,    42,    -1,    43,    -1,    44,
      -1,    45,    -1,    46,    -1,    47,    -1,    50,   281,     3,
      -1,    50,    49,   281,     3,    -1,    51,     3,    -1,    -1,
      18,    -1,   293,    52,    -1,    53,   266,    -1,    54,    55,
     264,    -1,    56,   266,    -1,   293,    57,    -1,    54,    55,
     264,    -1,    82,   272,   269,    -1,    52,    59,   264,    -1,
      60,    61,   288,   253,    -1,    13,    -1,    15,    -1,    16,
      -1,    89,    90,   290,   253,    -1,    -1,   290,   291,    -1,
      92,   267,    -1,    93,   264,    -1,    91,    -1,    59,    17,
      -1,    62,    -1,    -1,    17,    -1,    -1,    63,   264,    -1,
      64,   266,    -1,    39,   308,    -1,    67,   296,    -1,    68,
     296,    -1,    59,   297,    -1,    60,    61,   288,    -1,    69,
     349,    -1,   350,    -1,    38,    -1,    70,    -1,    17,    -1,
      39,    80,   308,    -1,    39,    86,   264,    -1,    -1,    18,
      -1,   268,    -1,    18,   268,    -1,    -1,    26,    -1,   299,
     301,   300,    -1,   302,    -1,   303,   257,   302,    -1,   293,
      65,    -1,   304,   294,   255,    -1,   305,   295,   253,    -1,
     305,   307,   253,    -1,    -1,    66,   306,   303,    -1,    38,
      -1,    33,    -1,   255,   309,   256,    -1,   310,    -1,   309,
     257,   310,    -1,    71,    -1,    72,    -1,    73,    -1,    81,
      -1,    78,    -1,    79,    -1,    94,   255,   312,   256,    -1,
     313,    -1,    -1,   313,   253,   312,    -1,   314,   255,   315,
     256,    -1,   314,    -1,    74,    18,    -1,    -1,    88,    75,
     271,   253,   315,    -1,    88,    77,   271,   253,   315,    -1,
     114,    75,   271,   253,   315,    -1,   114,    77,   271,   253,
     315,    -1,    61,   264,   253,   315,    -1,    95,    96,     3,
      -1,    95,    80,   319,     3,    -1,    95,    80,    38,   319,
       3,    -1,    17,    -1,    -1,    95,    81,     3,    -1,    95,
      81,    97,     3,    -1,    95,    98,   323,     3,    -1,    -1,
     323,   268,    -1,   323,    85,   269,    -1,   323,    59,    17,
      -1,   323,    69,   349,    -1,   323,   350,    -1,   323,    38,
      -1,   323,    82,    -1,   323,   324,    17,    -1,   323,    62,
      17,    -1,   323,    83,    -1,   323,    84,    -1,    87,    -1,
      68,    -1,    95,    99,   319,     3,    -1,   100,   101,     3,
      -1,   100,   102,     3,    -1,   100,    81,     3,    -1,   100,
     103,     3,    -1,   100,   104,     3,    -1,   100,    72,     3,
      -1,   100,    80,     3,    -1,   105,   334,   335,     3,    -1,
      38,    -1,    33,    -1,    13,    -1,    -1,    13,    -1,   106,
     340,     3,    -1,   107,   340,     3,    -1,   108,   340,     3,
      -1,    39,   340,   308,     3,    -1,    17,    -1,    38,    -1,
      18,    -1,    -1,    69,    17,   342,   348,    -1,   153,   376,
      -1,   117,    -1,   118,    -1,   119,    -1,   120,    -1,   121,
      -1,   123,    -1,   124,    -1,   125,    -1,   126,    -1,   344,
     122,    -1,   344,    17,    -1,    -1,   345,   253,   346,    -1,
     345,    -1,   347,   253,   345,    -1,   352,    -1,    17,    -1,
     348,    -1,   152,   376,    -1,   251,   347,   252,    -1,   251,
     252,    -1,   346,   255,   355,   256,    -1,    -1,   109,    17,
     354,   351,   352,    -1,    -1,   382,   355,    -1,   382,    -1,
     255,   355,   256,    -1,   251,    13,   257,    13,   252,    -1,
      16,    -1,    13,    -1,   357,    -1,   358,    -1,    14,    -1,
     359,    -1,   359,    24,    24,   359,    -1,   360,    -1,   361,
     257,   360,    -1,    16,    28,    13,    -1,   362,    -1,   362,
      25,    -1,   362,    26,    -1,   362,   255,    13,   257,    13,
     256,    -1,   363,    -1,   364,   257,   363,    -1,    -1,   360,
     254,   355,   365,    -1,   129,   254,   355,    -1,   374,    -1,
     251,   376,   252,    -1,    11,   368,    12,    -1,    28,   369,
      28,    -1,    13,   368,    -1,    27,   368,    -1,   258,   368,
      -1,   366,   368,    -1,    -1,    13,   369,    -1,   258,   369,
      -1,    -1,   251,   376,   257,   376,   252,    -1,    13,    -1,
     131,    -1,   132,    -1,    18,    -1,   358,    -1,   362,    -1,
     259,   361,   260,    -1,   259,   364,   260,    -1,    14,    -1,
     367,    -1,    -1,    17,   251,   381,   252,    -1,    17,    -1,
      75,    -1,   133,    -1,   134,    -1,   136,    -1,   137,    -1,
     138,    -1,   139,    -1,   140,    -1,   251,   376,   252,    -1,
     376,    25,   376,    -1,   376,    26,   376,    -1,   376,    27,
     376,    -1,   376,    28,   376,    -1,   376,     9,   376,    -1,
     376,    10,   376,    -1,   376,    20,   376,    -1,   376,     8,
     376,    -1,   376,    21,   376,    -1,   376,     7,   376,    -1,
     376,    22,   376,    -1,   376,     6,   376,    -1,   376,    23,
     376,    -1,    30,   376,    -1,   142,   251,   376,   252,    -1,
     374,    -1,   371,    -1,   370,    -1,    63,    -1,   372,   375,
      -1,   372,   440,    -1,   376,    24,   119,    -1,   376,    24,
     141,    -1,   376,    24,   135,   251,   376,   252,    -1,   376,
      24,   148,    -1,   376,    24,   149,    -1,    25,   151,    25,
      -1,    26,   151,    26,    -1,   147,   251,   376,   257,   376,
     252,    -1,   143,   251,   376,   257,   376,   252,    -1,   144,
     251,   376,   257,   376,   252,    -1,    17,   251,   381,   252,
      -1,   116,    -1,   114,    -1,   115,    -1,    44,    -1,   110,
      -1,   111,    -1,   376,    -1,    -1,   378,    -1,   378,   257,
     379,    -1,   376,    -1,   376,   257,   380,    -1,    -1,   380,
      -1,   127,   376,   128,   356,    -1,   127,   376,   128,   356,
     129,   356,    -1,    17,    20,   376,   253,    -1,   113,   376,
     253,    -1,   372,   440,    20,   376,   253,    -1,   372,   375,
      20,   376,   253,    -1,    63,    20,   376,   253,    -1,   112,
     251,   372,   440,   252,   253,    -1,   377,   379,   253,    -1,
     373,   253,    -1,   130,   376,   255,   365,   256,    -1,   372,
     440,    24,   151,   253,    -1,   372,   440,    24,   147,   251,
     376,   252,   253,    -1,   372,   440,    24,   143,   251,   376,
     252,   253,    -1,   372,   440,    24,   144,   251,   376,   252,
     253,    -1,   293,    90,    -1,   383,   294,   255,    -1,   384,
     295,   253,    -1,   384,   154,   156,   264,   253,    -1,   384,
     155,   267,   156,   264,   253,    -1,   384,   183,   186,    61,
     264,   253,    -1,   384,   183,   185,   253,    -1,   384,   184,
     185,   253,    -1,   384,   157,    55,   264,   253,    -1,   384,
     162,   157,    55,   264,   253,    -1,   384,   158,   159,    55,
     264,   253,    -1,   384,   160,    55,   264,   253,    -1,   384,
     161,   264,   163,   267,   253,    -1,   384,   164,   165,   166,
     253,    -1,   384,   168,   169,   266,   253,    -1,   384,   167,
     177,   264,   253,    -1,   384,   167,   176,   264,   253,    -1,
     384,   137,    92,   267,   253,    -1,   384,   170,   171,    55,
     264,   253,    -1,   384,    44,   172,    55,   264,   253,    -1,
     384,    44,   173,    55,   264,   257,   264,   253,    -1,   384,
     106,   174,    44,   266,   253,    -1,   384,   107,   187,   266,
     253,    -1,   384,   190,   266,   253,    -1,   384,   188,   189,
     266,   253,    -1,   384,    74,    18,   253,    -1,   384,    98,
     191,   264,   253,    -1,   384,    76,   266,   253,    -1,   293,
     192,    -1,   385,   294,   255,    -1,   386,   387,   253,    -1,
     295,    -1,   198,   266,    -1,   200,   264,    -1,   389,   256,
      -1,   193,   288,   255,    -1,   388,   390,    -1,    -1,   390,
     391,   253,    -1,   199,   201,   264,    -1,   199,   266,    -1,
     216,   255,   401,   256,    -1,   224,   392,    -1,    66,   412,
      -1,   396,    -1,   393,   255,   394,   256,    -1,   393,    -1,
     268,    -1,    -1,   394,   395,   253,    -1,   217,   266,    -1,
      97,   266,    -1,   201,   264,    -1,   399,   255,   397,   256,
      -1,   399,    -1,    -1,   397,   398,   253,    -1,    -1,   203,
     264,    -1,   202,   264,    -1,   204,   171,   264,    -1,   173,
     264,    -1,   206,   264,    -1,   206,    84,   264,    -1,   211,
      70,    -1,   211,   210,    -1,   211,   213,    -1,   311,    -1,
     218,   219,   288,    -1,   201,   264,    -1,   203,   264,    -1,
     215,   264,    -1,   202,   264,    -1,   204,   171,   264,    -1,
     205,   264,    -1,   173,   264,    -1,   206,   264,    -1,   206,
      84,   264,    -1,   209,   197,    -1,   209,   207,    -1,   209,
     208,    -1,   212,   207,   266,    -1,   199,   266,    -1,   103,
     255,   405,   256,    -1,   211,    70,    -1,   211,   210,    -1,
     211,   213,    -1,   220,   221,   222,    -1,   220,   221,   223,
      -1,   220,   221,   264,    -1,   311,    -1,    -1,   401,   402,
      -1,   403,    -1,   404,    -1,   268,   253,    -1,   268,   217,
     253,    -1,    -1,   405,   406,    -1,   407,    -1,   408,    -1,
      16,   253,    -1,    16,   214,   253,    -1,    -1,    -1,   410,
     400,   253,    -1,    -1,   255,   410,   256,    -1,   409,   303,
     411,    -1,    18,    -1,    -1,    95,   192,   319,     3,    -1,
      95,   192,   103,   319,   413,     3,    -1,    95,   192,    66,
     319,   413,     3,    -1,    95,   192,   225,   319,   413,     3,
      -1,    95,   192,   226,   319,   413,     3,    -1,   293,   227,
      -1,   419,   294,   255,    -1,   420,   295,   253,    -1,   420,
     228,    59,    17,   253,    -1,   420,   229,   230,   253,    -1,
     420,   229,   231,   253,    -1,   293,   232,    -1,   421,   294,
     255,    -1,   422,   295,   253,    -1,   422,   233,   264,   253,
      -1,   422,    93,   264,   253,    -1,   422,   234,   264,   253,
      -1,   422,   235,    55,   264,   253,    -1,   422,   236,    55,
     264,   253,    -1,   422,   211,   423,   253,    -1,   422,   311,
     253,    -1,   422,   243,   245,   253,    -1,   422,   243,   155,
     253,    -1,   422,   243,   244,   253,    -1,   422,    66,   429,
     253,    -1,   241,    -1,   242,    -1,    70,    -1,   197,    -1,
     237,    -1,   238,    -1,   239,    -1,   240,    -1,    -1,   169,
     264,    -1,   229,   424,    -1,    -1,   426,   425,   253,    -1,
      -1,   255,   426,   256,    -1,    -1,   428,   303,   427,    -1,
     293,   248,    -1,   430,   294,   255,    -1,   431,   295,   253,
      -1,   431,   433,   253,    -1,    98,   268,    -1,   432,   163,
     267,    -1,   432,   163,    18,    -1,   432,   249,    -1,   432,
     115,    -1,   432,   250,    -1,    95,   248,   319,     3,    -1,
     253,    -1,   265,    -1,   273,    -1,   287,    -1,   289,    -1,
     292,    -1,   437,    -1,   298,    -1,   341,    -1,   343,    -1,
     353,    -1,   278,    -1,   279,    -1,   280,    -1,   316,    -1,
     317,    -1,   318,    -1,   320,    -1,   321,    -1,   322,    -1,
     325,    -1,   326,    -1,   327,    -1,   328,    -1,   329,    -1,
     330,    -1,   331,    -1,   332,    -1,   333,    -1,   336,    -1,
     337,    -1,   338,    -1,   339,    -1,   414,    -1,   415,    -1,
     416,    -1,   417,    -1,   418,    -1,   434,    -1,   438,   256,
      -1,   439,   256,    -1,   305,   256,    -1,   384,   256,    -1,
     386,   256,    -1,   420,   256,    -1,   422,   256,    -1,   431,
     256,    -1,   282,   294,   255,    -1,   438,   295,   253,    -1,
     438,   283,   253,    -1,   438,   286,   253,    -1,   284,   294,
     255,    -1,   439,   295,   253,    -1,   439,   285,   253,    -1,
       5,    -1,   175,    -1,   176,    -1,   177,    -1,   178,    -1,
     179,    -1,   180,    -1,   181,    -1,   182,    -1,   194,    -1,
     195,    -1,   196,    -1,   246,    -1,   247,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   293,   293,   294,   297,   299,   306,   307,   308,   312,
     316,   325,   326,   327,   328,   329,   330,   336,   337,   344,
     351,   352,   356,   360,   367,   375,   376,   382,   391,   396,
     397,   401,   402,   406,   407,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   426,   429,   432,   436,   437,   445,
     461,   462,   466,   478,   491,   495,   508,   520,   526,   527,
     528,   539,   541,   543,   547,   548,   549,   556,   564,   568,
     574,   580,   582,   586,   587,   588,   589,   590,   591,   595,
     596,   597,   598,   602,   610,   611,   617,   625,   626,   627,
     631,   632,   636,   641,   642,   649,   658,   659,   660,   664,
     673,   679,   680,   681,   685,   686,   690,   691,   692,   693,
     694,   695,   701,   702,   705,   707,   711,   712,   716,   734,
     735,   736,   737,   738,   739,   747,   750,   753,   757,   758,
     761,   764,   767,   771,   777,   783,   790,   795,   800,   805,
     809,   813,   823,   831,   835,   842,   843,   846,   850,   852,
     854,   856,   858,   860,   862,   865,   871,   872,   873,   877,
     878,   884,   886,   888,   892,   897,   898,   899,   905,   905,
     914,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   946,   957,   958,   965,   966,   973,   982,   986,   990,
    1014,  1015,  1019,  1025,  1025,  1038,  1039,  1050,  1053,  1062,
    1069,  1073,  1074,  1075,  1076,  1080,  1085,  1093,  1094,  1098,
    1105,  1106,  1107,  1108,  1115,  1116,  1119,  1120,  1125,  1136,
    1137,  1141,  1142,  1146,  1147,  1148,  1149,  1150,  1154,  1155,
    1156,  1160,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,
    1181,  1182,  1192,  1196,  1219,  1252,  1254,  1255,  1256,  1257,
    1258,  1259,  1260,  1264,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,  1281,
    1282,  1283,  1285,  1287,  1289,  1291,  1292,  1293,  1294,  1295,
    1305,  1306,  1307,  1308,  1309,  1314,  1337,  1338,  1339,  1340,
    1341,  1342,  1346,  1349,  1350,  1351,  1360,  1367,  1376,  1377,
    1381,  1387,  1397,  1406,  1412,  1417,  1424,  1429,  1435,  1436,
    1437,  1445,  1447,  1448,  1449,  1455,  1473,  1474,  1475,  1476,
    1482,  1483,  1484,  1485,  1486,  1487,  1488,  1489,  1490,  1491,
    1492,  1493,  1494,  1495,  1496,  1497,  1498,  1499,  1500,  1501,
    1502,  1503,  1504,  1513,  1523,  1524,  1528,  1529,  1530,  1531,
    1534,  1546,  1549,  1551,  1555,  1556,  1557,  1558,  1559,  1560,
    1564,  1565,  1569,  1577,  1579,  1583,  1584,  1585,  1589,  1590,
    1593,  1595,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,
    1606,  1607,  1608,  1611,  1633,  1634,  1635,  1636,  1637,  1638,
    1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,  1652,  1653,  1654,  1657,  1659,  1663,  1664,
    1666,  1675,  1685,  1687,  1691,  1692,  1694,  1703,  1714,  1736,
    1738,  1741,  1743,  1747,  1751,  1752,  1756,  1759,  1762,  1765,
    1768,  1774,  1782,  1783,  1784,  1789,  1790,  1796,  1803,  1804,
    1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,
    1815,  1819,  1820,  1821,  1826,  1827,  1828,  1829,  1830,  1833,
    1834,  1835,  1838,  1840,  1843,  1845,  1849,  1858,  1865,  1872,
    1873,  1874,  1877,  1886,  1890,  1896,  1897,  1898,  1901,  1908,
    1908,  1908,  1908,  1908,  1908,  1908,  1908,  1908,  1908,  1908,
    1909,  1909,  1909,  1909,  1909,  1909,  1909,  1909,  1909,  1909,
    1909,  1909,  1909,  1909,  1909,  1909,  1909,  1909,  1909,  1909,
    1909,  1909,  1909,  1909,  1909,  1909,  1909,  1909,  1910,  1910,
    1910,  1910,  1910,  1910,  1910,  1910,  1911,  1911,  1911,  1911,
    1912,  1912,  1912,  1913,  1913,  1914,  1915,  1916,  1917,  1918,
    1919,  1920,  1921,  1921,  1921,  1921,  1921
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM", "ENUM", "RTRID",
  "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'", "'>'", "'~'", "'.'",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "DEFINE", "ON", "OFF", "YES",
  "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE",
  "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR", "SOFT",
  "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN",
  "DEVICE", "ASYNC", "TABLE", "ROUTER", "ID", "PROTOCOL", "PREFERENCE",
  "DISABLED", "DIRECT", "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE",
  "STATES", "ROUTES", "FILTERS", "PASSWORD", "FROM", "PASSIVE", "TO",
  "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES", "PRIMARY", "STATS",
  "COUNT", "FOR", "COMMANDS", "PREEXPORT", "GENERATE", "LISTEN", "BGP",
  "V6ONLY", "ADDRESS", "PORT", "PASSWORDS", "SHOW", "STATUS", "SUMMARY",
  "ROUTE", "SYMBOLS", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "ECHO", "DISABLE", "ENABLE", "RESTART", "FUNCTION",
  "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD",
  "INT", "BOOL", "IP", "PREFIX", "PAIR", "SET", "STRING", "BGPMASK",
  "BGPPATH", "CLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "GW",
  "NET", "MASK", "PROTO", "SOURCE", "SCOPE", "CAST", "DEST", "LEN",
  "DEFINED", "ADD", "DELETE", "CONTAINS", "RESET", "PREPEND", "FIRST",
  "LAST", "MATCH", "EMPTY", "WHERE", "EVAL", "LOCAL", "NEIGHBOR", "AS",
  "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "MULTIHOP", "STARTUP", "VIA",
  "NEXT", "HOP", "SELF", "DEFAULT", "PATH", "METRIC", "START", "DELAY",
  "FORGET", "WAIT", "AFTER", "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED",
  "BGP_ORIGIN", "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR",
  "BGP_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "LIMIT", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "BROADCAST", "RFC1583COMPAT", "STUB", "TICK",
  "COST", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD",
  "NONBROADCAST", "POINTOPOINT", "TYPE", "SIMPLE", "AUTHENTICATION",
  "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN",
  "VIRTUAL", "LINK", "RX", "BUFFER", "LARGE", "NORMAL", "STUBNET",
  "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT",
  "RIP", "INFINITY", "PERIOD", "GARBAGE", "TIMEOUT", "MULTICAST", "QUIET",
  "NOLISTEN", "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS",
  "RIP_METRIC", "RIP_TAG", "STATIC", "DROP", "PROHIBIT", "'('", "')'",
  "';'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "expr", "definition", "bool", "ipa", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text_or_none", "log_config",
  "log_file", "log_mask", "log_mask_list", "log_cat", "cmd_CONFIGURE",
  "cmd_CONFIGURE_SOFT", "cmd_DOWN", "cfg_name", "kern_proto_start",
  "kern_item", "kif_proto_start", "kif_item", "nl_item", "rtrid", "idval",
  "listen", "listen_opts", "listen_opt", "newtab", "proto_start",
  "proto_name", "proto_item", "imexport", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL", "optsym",
  "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE",
  "r_args", "export_or_preexport", "cmd_SHOW_SYMBOLS",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_DEBUG", "proto_patt",
  "filter_def", "$@1", "filter_eval", "type", "one_decl", "decls",
  "declsn", "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "block", "cpair", "fipa",
  "set_atom", "set_item", "set_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "dpair", "constant", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bgp_proto_start", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_el", "pref_hid",
  "ipa_list", "ipa_item", "ipa_el", "ipa_ne", "ospf_iface_start",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_STATE", "pipe_proto_start",
  "pipe_proto", "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode",
  "rip_iface_item", "rip_iface_opts", "rip_iface_opt_list",
  "rip_iface_init", "rip_iface", "static_proto_start", "static_proto",
  "stat_route0", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      61,    60,    62,   126,    46,    43,    45,    42,    47,    37,
      33,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,    40,    41,    59,    58,   123,   125,    44,    63,    91,
      93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   261,   262,   262,   263,   263,   264,   264,   264,   265,
     265,   266,   266,   266,   266,   266,   266,   267,   267,   268,
     269,   269,   270,   270,   271,   272,   272,   273,   274,   274,
     274,   275,   275,   276,   276,   277,   277,   277,   277,   277,
     277,   277,   277,   277,   278,   279,   280,   281,   281,   282,
     283,   283,   283,   284,   285,   285,   286,   287,   288,   288,
     288,   289,   290,   290,   291,   291,   291,   292,   293,   294,
     294,   295,   295,   295,   295,   295,   295,   295,   295,   296,
     296,   296,   296,   297,   298,   298,   299,   300,   300,   300,
     301,   301,   302,   303,   303,   304,   305,   305,   305,   306,
     307,   308,   308,   308,   309,   309,   310,   310,   310,   310,
     310,   310,   311,   311,   312,   312,   313,   313,   314,   315,
     315,   315,   315,   315,   315,   316,   317,   318,   319,   319,
     320,   321,   322,   323,   323,   323,   323,   323,   323,   323,
     323,   323,   323,   323,   323,   324,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   334,   334,   335,
     335,   336,   337,   338,   339,   340,   340,   340,   342,   341,
     343,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   345,   346,   346,   347,   347,   348,   349,   349,   350,
     351,   351,   352,   354,   353,   355,   355,   356,   356,   357,
     358,   359,   359,   359,   359,   360,   360,   361,   361,   362,
     363,   363,   363,   363,   364,   364,   365,   365,   365,   366,
     366,   367,   367,   368,   368,   368,   368,   368,   369,   369,
     369,   370,   371,   371,   371,   371,   371,   371,   371,   371,
     371,   371,   372,   373,   374,   375,   375,   375,   375,   375,
     375,   375,   375,   376,   376,   376,   376,   376,   376,   376,
     376,   376,   376,   376,   376,   376,   376,   376,   376,   376,
     376,   376,   376,   376,   376,   376,   376,   376,   376,   376,
     376,   376,   376,   376,   376,   376,   377,   377,   377,   377,
     377,   377,   378,   379,   379,   379,   380,   380,   381,   381,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   383,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   385,   386,   386,   387,   387,   387,   387,
     388,   389,   390,   390,   391,   391,   391,   391,   391,   391,
     392,   392,   393,   394,   394,   395,   395,   395,   396,   396,
     397,   397,   398,   398,   398,   398,   398,   398,   398,   398,
     398,   398,   398,   399,   400,   400,   400,   400,   400,   400,
     400,   400,   400,   400,   400,   400,   400,   400,   400,   400,
     400,   400,   400,   400,   400,   400,   401,   401,   402,   402,
     403,   404,   405,   405,   406,   406,   407,   408,   409,   410,
     410,   411,   411,   412,   413,   413,   414,   415,   416,   417,
     418,   419,   420,   420,   420,   420,   420,   421,   422,   422,
     422,   422,   422,   422,   422,   422,   422,   422,   422,   422,
     422,   423,   423,   423,   424,   424,   424,   424,   424,   425,
     425,   425,   426,   426,   427,   427,   428,   429,   430,   431,
     431,   431,   432,   433,   433,   433,   433,   433,   434,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   437,   437,
     437,   437,   437,   437,   437,   437,   438,   438,   438,   438,
     439,   439,   439,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       1,     1,     2,     2,     1,     1,     0,     4,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     4,     2,     0,     1,     2,
       2,     3,     2,     2,     3,     3,     3,     4,     1,     1,
       1,     4,     0,     2,     2,     2,     1,     2,     1,     0,
       1,     0,     2,     2,     2,     2,     2,     2,     3,     2,
       1,     1,     1,     1,     3,     3,     0,     1,     1,     2,
       0,     1,     3,     1,     3,     2,     3,     3,     3,     0,
       3,     1,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     4,     1,     0,     3,     4,     1,     2,     0,
       5,     5,     5,     5,     4,     3,     4,     5,     1,     0,
       3,     4,     4,     0,     2,     3,     3,     3,     2,     2,
       2,     3,     3,     2,     2,     1,     1,     4,     3,     3,
       3,     3,     3,     3,     3,     4,     1,     1,     1,     0,
       1,     3,     3,     3,     4,     1,     1,     1,     0,     4,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     0,     3,     1,     3,     1,     1,     1,     2,
       3,     2,     4,     0,     5,     0,     2,     1,     3,     5,
       1,     1,     1,     1,     1,     1,     4,     1,     3,     3,
       1,     2,     2,     6,     1,     3,     0,     4,     3,     1,
       3,     3,     3,     2,     2,     2,     2,     0,     2,     2,
       0,     5,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     4,     1,
       1,     1,     1,     2,     2,     3,     3,     6,     3,     3,
       3,     3,     6,     6,     6,     4,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     3,     1,     3,     0,     1,
       4,     6,     4,     3,     5,     5,     4,     6,     3,     2,
       5,     5,     8,     8,     8,     2,     3,     3,     5,     6,
       6,     4,     4,     5,     6,     6,     5,     6,     5,     5,
       5,     5,     5,     6,     6,     8,     6,     5,     4,     5,
       4,     5,     4,     2,     3,     3,     1,     2,     2,     2,
       3,     2,     0,     3,     3,     2,     4,     2,     2,     1,
       4,     1,     1,     0,     3,     2,     2,     2,     4,     1,
       0,     3,     0,     2,     2,     3,     2,     2,     3,     2,
       2,     2,     1,     3,     2,     2,     2,     2,     3,     2,
       2,     2,     3,     2,     2,     2,     3,     2,     4,     2,
       2,     2,     3,     3,     3,     1,     0,     2,     1,     1,
       2,     3,     0,     2,     1,     1,     2,     3,     0,     0,
       3,     0,     3,     3,     1,     0,     4,     6,     6,     6,
       6,     2,     3,     3,     5,     4,     4,     2,     3,     3,
       4,     4,     4,     5,     5,     4,     3,     4,     4,     4,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     2,     0,     3,     0,     3,     0,     3,     2,     3,
       3,     3,     2,     3,     3,     2,     2,     2,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    47,     0,     0,     0,     0,
       0,     0,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,     3,     1,     2,     0,     0,     0,     0,     0,    68,
       0,     0,     0,   242,   479,   480,   481,    69,    69,   482,
     483,   484,     0,   486,    69,    71,   487,   488,   489,    69,
      71,    69,    71,    69,    71,    69,    71,    69,    71,     5,
     485,    71,    71,   165,   167,   166,     0,    48,    47,     0,
      46,   129,     0,     0,   133,   129,   129,   129,     0,     0,
       0,     0,     0,     0,     0,   158,   157,   156,   159,     0,
       0,     0,     0,    28,    29,    30,     0,     0,     0,    67,
       0,   168,    62,   193,   227,   232,   240,   200,   244,   235,
       0,     0,   230,   242,   272,   233,   234,     0,     0,     0,
       0,   242,     0,   236,   237,   241,   271,   270,     0,   269,
     170,    70,     0,     0,    49,    53,    95,   315,   343,   431,
     437,   468,     0,     0,     0,     0,     0,    16,    99,     0,
       0,   520,     0,     0,     0,     0,     0,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,   521,     0,     0,
       0,    16,     0,   522,   346,     0,   352,     0,     0,     0,
       0,   523,     0,     0,   466,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   524,     0,     0,   113,   117,     0,
       0,   525,     0,     0,     0,     0,    16,     0,    16,   518,
       0,     0,     0,     0,    26,   519,     0,     0,   102,   101,
       0,     0,     0,    44,   128,   129,     0,   130,     0,   125,
       0,     0,   129,   129,   129,   129,     0,     0,   153,   154,
     150,   148,   149,   151,   152,   160,     0,   161,   162,   163,
       0,    31,     0,     0,    84,     6,     8,   242,    85,    58,
      59,    60,     0,   182,     0,     0,   227,   244,   227,   242,
     227,   227,     0,   219,     0,   242,     0,     0,   230,   230,
       0,   267,   242,   242,   242,   242,     0,   201,   204,     0,
     202,   203,   205,   207,     0,   210,   214,     0,   533,   245,
     246,   247,   248,   249,   250,   251,   252,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     273,   274,   242,   242,   242,   242,   242,   242,   242,   242,
     242,     0,   242,   242,   242,   242,   526,   530,    96,    74,
      83,    77,     0,    72,    12,    14,    13,    15,    11,    73,
      86,    81,   182,    82,   242,    75,    80,    76,    97,    98,
     316,     0,     0,     0,     0,     0,     0,    16,     0,     0,
      17,    18,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,     0,     0,     0,     0,    16,     0,   317,   344,
       0,   347,   348,   345,   351,   349,   432,     0,     0,     0,
     433,   438,    86,     0,   118,     0,   114,   453,   451,   452,
       0,     0,     0,     0,     0,     0,     0,     0,   439,   446,
     119,   469,     0,   472,   470,   476,     0,   475,   477,   471,
       0,    50,     0,    52,   528,   529,   527,     0,    25,     0,
     532,   531,   106,   107,   108,   110,   111,   109,     0,   104,
     164,    45,     0,   126,   131,   132,   139,     0,     0,   146,
     182,   140,   143,   144,     0,   145,   134,     0,   138,   147,
     425,   425,   425,   425,   426,   478,   155,     0,     0,    35,
      36,    37,    38,    39,    40,    41,    42,    43,     0,    33,
      27,     0,    57,   171,   172,   173,   174,   175,   176,   177,
     178,   179,     0,     0,     0,   169,   186,    66,     0,     0,
      61,    63,     0,   182,   223,   224,     0,   225,   226,   221,
     209,   296,   299,     0,   280,   281,   228,   229,   222,     0,
       0,     0,     0,   253,   242,     0,     0,     0,   238,   211,
     212,     0,     0,   239,   265,   263,   261,   258,   259,   260,
     262,   264,   266,   275,     0,   276,   278,   279,   254,   255,
     256,   257,    78,    90,    93,   100,   187,   188,    79,   189,
       0,     0,   340,   342,     0,    16,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     321,     0,   322,     0,   338,   350,   418,    16,     0,     0,
       0,     0,   359,   369,     0,   435,   436,   464,   450,   441,
       0,     0,   445,   440,   442,     0,     0,   448,   449,   447,
       0,     0,     0,     0,     0,     0,    19,   474,   473,    56,
      51,    54,    21,    20,    55,   103,     0,   127,   136,   142,
     137,   135,   141,   424,     0,     0,     0,     0,    10,     9,
      32,     0,     7,   181,   180,   182,   242,    64,    65,   191,
     184,     0,   194,   220,   242,   285,   268,   242,   242,   242,
       0,     0,     0,   200,   208,     0,     0,   215,   242,    91,
       0,    86,     0,     0,   341,     0,   337,   332,   318,     0,
     323,     0,   326,     0,     0,   328,   331,   330,   329,     0,
       0,   339,    86,   358,     0,   355,   406,     0,   362,   357,
     361,   353,   370,   434,   462,   467,   112,   114,   443,   444,
       0,     0,     0,     0,     0,   116,    22,    23,   105,   428,
     427,   429,   430,    34,   183,     0,   289,     0,   290,   291,
       0,   242,   287,   288,   286,   242,   242,     0,     0,     0,
     242,   242,   190,     0,   297,     0,     0,     0,   231,     0,
     206,     0,     0,    87,    88,    92,    94,   334,     0,   336,
     319,   325,   327,   324,   333,   320,   421,   354,     0,   383,
     363,   372,   459,   115,   119,    24,     0,     0,     0,     0,
     242,   242,   242,   242,     0,     0,     0,   192,     0,     0,
     309,   292,   294,     0,   196,   185,   283,   284,   282,   199,
       0,   277,    89,     0,   419,   423,   356,     0,   407,   408,
     409,     0,     0,     0,     0,     0,     0,     0,   368,   382,
       0,     0,     0,   465,     0,   124,   119,   119,   119,   119,
       0,     0,     0,     0,   303,   242,   216,   242,   242,     0,
     242,   308,   213,   335,     0,     0,   410,    16,     0,    16,
     360,     0,   376,   374,   373,     0,     0,   377,   379,   380,
     381,   371,   460,   454,   455,   456,   457,   458,   461,   463,
     120,   121,   122,   123,   302,   243,   306,     0,   242,   300,
     197,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     295,     0,     0,    16,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   422,   405,     0,   411,   366,
     367,   365,   364,   375,   378,     0,     0,   242,   242,   242,
     310,   305,   304,   242,   242,   242,   311,   412,   390,   397,
     384,   387,   385,     0,   389,     0,   391,   393,   394,   395,
     399,   400,   401,    16,   386,     0,   420,   307,   198,   301,
     218,   216,     0,     0,     0,     0,   388,   392,   396,   402,
     403,   404,   217,     0,     0,     0,     0,   398,   413,   414,
     415,   313,   314,   312,     0,   416,   417
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   378,    55,   379,   452,   663,   664,   656,
     816,   469,    56,   116,   283,   518,   519,    13,    14,    15,
      89,    57,   240,    58,   246,   241,    59,   292,    60,   294,
     541,    61,    62,   152,   172,   385,   371,    63,   593,   795,
     710,   594,   595,    64,    65,   380,   173,   251,   478,   479,
     226,   640,   227,   228,   653,    16,    17,    18,   256,    19,
      20,    21,   260,   497,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   108,   276,    31,    32,    33,    34,    86,
      66,   293,    67,   532,   533,   534,   691,   597,   598,   386,
     543,   536,    68,   295,   777,   919,   320,   143,   322,   922,
     324,   144,   326,   327,   923,   301,   145,   302,   310,   146,
     147,   148,   779,   149,   350,   551,   780,   832,   833,   552,
     553,   781,    69,    70,    71,    72,   205,   206,   207,   424,
     631,   739,   740,   851,   891,   632,   811,   860,   633,   947,
     808,   848,   849,   850,   995,  1008,  1009,  1010,   732,   884,
     845,   733,   674,    35,    36,    37,    38,    39,    73,    74,
      75,    76,   440,   908,   864,   812,   745,   432,   433,    77,
      78,   233,   234,    40,    79,    41,    80,    81,    82,   351
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -844
static const yytype_int16 yypact[] =
{
      85,  1364,   123,   155,   401,    48,   157,   621,   627,   200,
     401,   401,   401,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,   159,    50,   -15,   171,   151,  -844,
     204,   128,   215,   444,  -844,  -844,  -844,   218,   218,  -844,
    -844,  -844,  1067,  -844,   218,  1027,  -844,  -844,  -844,   218,
    1212,   218,  1013,   218,   833,   218,  1078,   218,  1121,  -844,
    -844,   499,   530,  -844,  -844,  -844,   154,  -844,   221,   273,
    -844,   139,   146,   277,  -844,   268,   264,   268,   329,   356,
     368,   386,   390,   400,   403,  -844,  -844,  -844,   334,   414,
     417,   430,   415,  -844,  -844,  -844,   -18,   154,    83,  -844,
     307,  -844,  -844,  -844,    -2,  -844,  -844,   416,   208,  -844,
     300,   322,    -1,   444,  -844,  -844,  -844,   250,   252,   288,
     299,   444,    46,  -844,  -844,  -844,  -844,  -844,  1059,  -844,
    1467,  -844,   260,   310,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,   317,   154,   553,   513,    83,   176,  -844,   279,
     279,  -844,   324,   325,   326,    75,   562,   176,   394,   418,
     412,   514,   451,   163,   561,   459,   564,    83,   469,   463,
     234,   460,   472,   238,   445,   442,   176,  -844,   427,   398,
     307,   176,    83,  -844,  -844,   429,  -844,   428,   399,   624,
      64,  -844,   437,   449,  -844,   678,    83,   454,   -37,    83,
      83,   642,   645,  -124,  -844,   452,   453,  -844,   455,   456,
     163,  -844,   462,   114,   468,   654,   176,   661,   176,  -844,
     471,   473,   479,   670,   715,  -844,   481,   487,  -844,  -844,
     441,   738,   739,  -844,  -844,   268,   740,  -844,   749,  -844,
    1348,   751,   268,   268,   268,   268,   753,   754,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,   757,  -844,  -844,  -844,
      65,  -844,   794,   508,  -844,  -844,  -844,   444,  -844,  -844,
    -844,  -844,   510,   686,   -63,   522,    -2,  -844,    -2,   444,
      -2,    -2,   763,  -844,   764,   344,   760,   750,    -1,    -1,
     759,  -844,   444,   444,   444,   444,    84,  -844,  -844,   775,
    -844,  -844,   765,  -844,  -193,    20,  -844,  -185,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,   444,   444,   444,   444,   444,   444,   444,   444,
     444,   315,   444,   444,   444,   444,  -844,  -844,  -844,  -844,
    -844,  -844,   307,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,  1328,  -844,   444,  -844,  -844,  -844,  -844,  -844,
    -844,   735,   736,   539,   540,    83,   770,   176,   163,    83,
    -844,  -844,   660,    83,   768,    83,   688,   797,   689,    83,
      83,   176,   799,   604,   803,   612,   176,   613,  -844,  -844,
     615,  -844,  -844,  -844,   355,  -844,  -844,   854,   629,   630,
    -844,  -844,  -844,   631,  -844,   632,   812,  -844,  -844,  -844,
     634,   636,   637,    83,    83,   646,   649,   656,  -844,  -844,
     254,  -844,   -12,  -844,  -844,  -844,   335,  -844,  -844,  -844,
      83,  -844,    83,  -844,  -844,  -844,  -844,    83,  -844,   163,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,   239,  -844,
    -844,  -844,   885,  -844,  -844,  -844,  -844,   878,   881,  -844,
    1328,  -844,  -844,  -844,   163,  -844,  -844,   924,  -844,  -844,
     925,   925,   925,   925,  -844,  -844,  -844,   691,   720,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,   242,  -844,
    -844,   774,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,    26,   721,   687,  -844,  -844,  -844,   163,    83,
    -844,  -844,   568,   686,  -844,  -844,   822,  -844,  -844,  -844,
    -844,    30,  -844,   723,  -844,  -844,  -844,  -844,  -844,   853,
     109,   118,   144,  -844,   444,   719,   982,    63,  -844,  -844,
    -844,   995,   991,  -844,  1495,  1495,  1495,  1495,  1495,  1495,
    1495,  1495,  1495,  -844,   772,  -844,  -844,  -844,   312,   312,
    -844,  -844,  -844,   985,  -844,   767,  -844,  -844,  -844,  1467,
      83,    83,  -844,  -844,   780,   176,   781,   782,   783,    83,
     784,    83,   785,   163,    83,   786,   800,   801,   802,    83,
    -844,    83,  -844,   804,  -844,  -844,  -844,   381,   795,   806,
     163,   805,  -844,   808,   807,  -844,  -844,   -27,  -844,  -844,
     809,   814,  -844,  -844,  -844,   815,   816,  -844,  -844,  -844,
      83,   269,   309,   819,    83,   163,  -844,  -844,  -844,  -844,
    -844,  -844,   -12,  -844,  -844,  -844,   441,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,  1053,  1068,  1075,  1076,  -844,  -844,
    -844,   794,  -844,  -844,  -844,   686,   635,  -844,  -844,  -844,
    -844,   308,  -844,  -844,   444,  -844,  -844,   444,   444,   444,
     898,  1057,    63,  -844,  -844,   825,   416,  -844,   444,  -844,
     450,  -844,   830,   827,  -844,   832,  -844,  -844,  -844,   835,
    -844,   839,  -844,   843,   844,  -844,  -844,  -844,  -844,   860,
     861,  -844,  -844,  -844,    83,  -844,  -844,   307,  -844,  -844,
     865,  -844,  -844,  -844,  -844,  -844,  -844,   812,  -844,  -844,
     863,  1103,  1103,  1103,  1103,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,   -11,  -844,  1102,  -844,  -844,
     876,   444,  -844,  -844,  -844,   444,   444,   872,  1059,   877,
     374,   996,  -844,   686,  -844,   907,   930,   939,  -844,   879,
    -844,  1116,   962,   163,  -844,  -844,  -844,  -844,    83,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,    99,  -844,     7,  -844,
    -844,  1150,  -155,  -844,   254,  -844,   880,   882,   883,   886,
     444,   344,   444,  -844,   175,  1416,   245,  -844,  1120,    49,
    -844,  1467,   890,   895,  -844,  -844,  -844,  -844,  -844,  -844,
     887,  -844,  -844,   896,  -844,  -844,  -844,  -169,  -844,  -844,
    -844,   276,    83,    83,    83,   980,   161,   -51,  -844,  -844,
     900,    83,   241,  -844,   901,  -844,   254,   254,   254,   254,
     521,   903,   614,   201,  -844,   988,    28,   444,   444,   302,
     374,  -844,  -844,  -844,  1127,   905,  -844,   176,    83,   176,
    -844,   908,  -844,  -844,  -844,    83,    83,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,   904,   635,  1034,
    -844,   911,   913,   919,   641,   650,   918,   926,   927,   923,
    -844,   928,    83,   176,    83,    83,    83,  1008,    83,   214,
     121,    13,   979,    83,   966,  -844,  -844,   937,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,   941,   944,   988,   635,   996,
    -844,  -844,  -844,   444,   444,   444,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,    83,  -844,    83,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,   176,  -844,   203,  -844,  -844,  -844,  -844,
    -844,    28,   971,   994,  1021,    18,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,   949,   950,   951,  -167,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,   952,  -844,  -844
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -844,  -844,  -844,  -117,  -844,  -175,  -173,  -225,   713,  -844,
    -244,  -844,  -844,  -844,  -844,  -844,   527,  -844,  -844,  -844,
    1122,  -844,  -844,  -844,  -844,  -844,  -844,  -197,  -844,  -844,
    -844,  -844,  -844,   695,  1092,  1039,  -844,  -844,  -844,  -844,
    -844,   501,  -419,  -844,  -844,  -844,  -844,    56,  -844,   549,
    -789,   470,  -428,  -844,  -343,  -844,  -844,  -844,   346,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,   524,
    -844,  -844,  -844,  -844,  -525,   531,  -844,   929,   728,   960,
    -844,   682,  -844,  -844,  -634,   270,  -844,  -138,   526,  -135,
    -844,  -136,   657,  -844,   235,  -844,  -844,   304,   248,  -844,
    -844,  -668,  -844,    37,   464,   -53,  -844,  -844,   351,   538,
     424,  -843,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,   112,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,
    -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -844,  -751
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -299
static const yytype_int16 yytable[] =
{
     150,   288,   394,   420,   321,   453,   325,   323,   641,   820,
     402,   296,   308,   637,   861,   297,   654,   690,   778,   898,
     281,   417,   859,   400,   401,   298,   421,   829,   537,   538,
     539,   445,   920,   437,  1006,   496,   352,   353,   354,   355,
     356,   317,   318,   683,   703,   569,   570,  1014,   885,   373,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   317,
     318,   461,   127,   463,   567,   117,    87,   568,   113,   878,
     406,   118,   572,   879,   862,   573,   317,   318,   285,   703,
     311,   507,   286,   980,   886,   422,  1015,   114,   316,     1,
     352,   353,   354,   355,   356,   946,   285,    88,   115,   435,
     286,   863,   441,   442,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   778,   920,   352,   353,   354,   355,   356,
     446,   447,   917,    42,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   834,   684,   257,
     352,   353,   354,   355,   356,   873,   254,   921,    43,   899,
      90,   303,   900,   508,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   284,   285,   592,   112,   255,   286,   400,
     401,   352,   353,   354,   355,   356,    44,   248,   119,   285,
     540,    45,   249,   286,    46,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   438,   439,   328,   778,   374,   375,
     376,   377,   120,   105,    47,    48,   285,    49,   122,   369,
     286,   121,   606,   981,    50,   607,   982,   285,   744,   455,
     711,   286,   123,   106,   521,   151,   618,   282,   107,    87,
     821,   623,   655,   258,    51,   896,   546,   391,   392,   299,
     778,   352,   353,   354,   355,   356,   300,   309,   835,   559,
     560,   561,   562,   846,    52,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1007,   571,   253,   456,   604,   319,
     259,   254,   608,   658,   956,   254,   610,   694,   612,   778,
     778,   778,   616,   617,   428,   429,   662,   319,   975,   574,
     575,   576,   577,   578,   579,   580,   581,   582,    53,   588,
     589,   590,   591,   806,   319,   650,   287,   381,   977,   641,
     289,   662,   290,   291,   990,   991,   645,   646,   978,   979,
     262,   599,   268,   303,   287,   303,   563,   303,   303,   364,
     365,   564,   651,   659,   751,   660,   752,   275,   382,   383,
     661,   400,   401,   657,   844,   124,   711,   125,   126,   269,
     127,   128,   129,   457,   458,   687,   697,   263,   652,   130,
     131,   270,   132,   887,   133,   698,   337,   338,   339,   340,
     341,   342,   343,   344,   753,   124,   754,   125,   126,   271,
     127,   128,   129,   272,   285,   345,   346,   347,   286,   130,
     131,   699,   132,   273,   133,   738,   274,   134,    54,   250,
     409,   410,   287,   374,   375,   376,   377,   277,    83,    84,
     278,   626,   688,   413,   414,   999,  1000,   287,   874,   321,
     715,   384,   704,   279,   583,   280,   325,   134,   903,    85,
     723,   261,   266,   267,   304,   926,   927,   348,   349,   928,
     584,   306,   735,   929,   287,   124,   585,   125,   126,   305,
     127,   128,   129,   586,   587,   287,   400,   401,   793,   130,
     131,   865,   132,   307,   133,   135,   136,   888,   904,   905,
     906,   907,   757,   712,   713,   794,   137,   138,   139,   264,
     265,   140,   719,   889,   721,   665,   666,   724,   680,   681,
     876,   312,   729,   313,   730,   135,   136,   134,   817,   818,
     819,   700,   472,   473,   474,   366,   137,   138,   139,   475,
     476,   140,   477,   910,   911,   912,   913,   352,   353,   354,
     355,   356,   890,   750,   109,   110,   111,   756,   163,   314,
     809,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     315,   235,   236,   237,   627,   238,   556,   557,   164,   165,
     782,   783,   166,   167,   321,   367,   169,   170,   842,   163,
     370,   628,   368,   629,   372,   135,   136,   388,   389,   630,
     393,   390,   734,   847,   243,   395,   137,   138,   139,   164,
     165,   140,   396,   166,   167,   141,  -298,   169,   170,   397,
     544,   482,   545,   142,   547,   548,   398,   399,   500,   501,
     502,   503,   244,   675,   676,   677,   403,   807,   404,   405,
     352,   353,   354,   355,   356,   141,   407,  -293,   408,   411,
     415,   416,   287,   142,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   412,   785,   786,   787,   352,   353,   354,
     355,   356,   765,   419,   426,   792,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   766,
     418,   843,   423,   427,   425,   523,   524,   525,   526,   527,
     430,   528,   529,   530,   531,   141,   434,   443,   767,    98,
     444,    91,    92,   142,   431,   448,   449,    99,   100,   436,
     450,   451,   949,   460,   951,   454,   462,    93,   824,    94,
      95,   459,   825,   826,   464,   467,   465,   831,   101,   102,
     103,   104,   466,   468,   470,   892,   893,   894,   321,   897,
     471,   480,   481,   483,   902,   768,   769,   770,   771,   772,
     773,   774,   484,   153,   499,   239,   504,   505,   969,   162,
     506,   520,   775,   522,   174,   776,   199,   870,   208,   872,
     213,   950,   229,   542,   914,   549,   555,   550,   953,   954,
     352,   353,   354,   355,   356,   554,   245,   558,   565,   566,
     600,   601,   602,   603,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   523,   524,   525,   526,   527,   998,   528,
     529,   530,   531,    96,   605,   968,   609,   970,   971,   972,
     689,   974,   976,   611,   924,   925,   984,   831,   352,   353,
     354,   355,   356,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   613,   614,   321,   619,   615,   996,   620,   997,   352,
     353,   354,   355,   356,   621,   622,   624,   916,  1001,    97,
     625,   634,   163,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   635,   636,   638,   639,   215,   642,   667,   643,
     644,  -195,   164,   165,   961,   668,   166,   167,   669,   647,
     169,   170,   648,   962,   352,   353,   354,   355,   356,   649,
     992,   993,   994,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   352,   353,   354,   355,
     356,   672,   686,   673,   678,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   352,   353,
     354,   355,   356,   679,   685,   695,   701,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     352,   353,   354,   355,   356,   765,   702,   706,   705,  -195,
    -195,   709,  -195,   765,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   708,   711,   737,   682,   352,   353,   354,
     355,   356,   766,   714,   716,   717,   718,   720,   722,   725,
     766,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     736,   767,   163,   726,   727,   728,   759,   731,   741,   767,
     743,   209,   210,   742,   328,   746,   163,   747,   748,   749,
     789,   760,   164,   165,   693,   755,   166,   167,   761,   762,
     169,   170,   791,   797,   798,   799,   164,   165,   800,   211,
     166,   167,   801,   168,   169,   170,   802,   803,   768,   769,
     770,   771,   772,   773,   774,   696,   768,   769,   770,   771,
     772,   773,   774,   804,   805,   775,   814,   163,   776,   154,
     810,   815,   822,   775,   155,  -195,   776,   823,   827,   840,
     830,   839,   156,   866,   329,   867,   868,   164,   165,   869,
     877,   166,   167,   882,   214,   169,   170,   880,   881,   883,
     788,   895,   215,   901,   909,   915,   955,   157,   948,   836,
     163,   952,   198,   957,   204,   958,   212,   959,   225,   963,
     232,   216,   217,   242,   247,   960,   966,   964,   965,   973,
     164,   165,   837,   967,   166,   167,   983,   985,   169,   170,
     986,   838,   330,   331,   987,   332,   333,   334,   335,   336,
     988,   215,  1011,  1012,  1013,  1016,   200,   671,   763,   387,
     252,   201,   796,   202,   841,   758,   764,   813,   670,   230,
     498,   217,   535,  1003,   215,   692,  1002,   989,   790,   707,
     931,   930,   784,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   828,   918,   217,   871,  1004,  -195,     0,     0,
       0,   163,  -195,   345,   346,   347,   175,     0,     0,   158,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   203,
       0,   164,   165,  1005,     0,   166,   167,     0,     0,   169,
     170,     0,     0,   171,     0,     0,   176,     0,   177,   218,
       0,     0,     0,     0,   159,     0,     0,     0,     0,   160,
     932,     0,     0,     0,     0,   348,   349,     0,     0,     0,
     178,   219,   220,   221,   222,   161,     0,     0,   179,   180,
       0,   223,     0,   852,     0,     0,   933,     0,   934,   935,
     936,   937,   938,   939,   224,     0,   940,     0,   941,   942,
       0,     0,   943,     0,     0,   596,     0,   944,     0,   181,
       0,   485,   853,   854,   855,     0,   856,     0,     0,     0,
       0,   857,     0,     0,   400,   401,   182,   183,     0,   184,
     185,     0,   186,   187,   188,     0,   189,   231,     0,   190,
     191,     0,   192,   945,     0,     0,   486,     0,     0,     0,
       0,     0,     0,     0,     0,   193,   194,     0,     0,     0,
     195,     0,   196,     4,     0,     0,   858,   487,     0,     0,
     488,     0,     0,     0,     5,     6,   489,   490,     0,     0,
       0,     0,   352,   353,   354,   355,   356,     0,     0,     0,
     491,   492,   493,   494,     0,   495,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   523,   524,   525,   526,   527,
       0,   528,   529,   530,   531,     0,     0,     0,     0,     7,
       0,     0,     0,     0,     8,     0,     0,     0,   197,     9,
      10,    11,    12,   352,   353,   354,   355,   356,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,     0,     0,     0,
     384,  -299,  -299,  -299,  -299,  -299,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -299,  -299,  -299,  -299,  -299,
     362,   363,   364,   365,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   875
};

static const yytype_int16 yycheck[] =
{
      53,   118,   177,   200,   142,   230,   142,   142,   436,    20,
     183,    13,    13,   432,   169,    17,    28,   542,   686,    70,
      38,   196,   811,    16,    17,    27,   201,   778,    91,    92,
      93,   155,   875,    70,    16,   260,     6,     7,     8,     9,
      10,    13,    14,    17,    16,    25,    26,   214,   217,   166,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    13,
      14,   236,    16,   238,   257,    80,    18,   260,    18,    20,
     187,    86,   257,    24,   229,   260,    13,    14,    13,    16,
     133,    16,    17,    70,   253,   202,   253,    37,   141,     4,
       6,     7,     8,     9,    10,   884,    13,    49,    48,   216,
      17,   256,   219,   220,    20,    21,    22,    23,    24,    25,
      26,    27,    28,   781,   957,     6,     7,     8,     9,    10,
     244,   245,   873,     0,     6,     7,     8,     9,    10,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    20,    21,
      22,    23,    24,    25,    26,    27,    28,   781,   122,     3,
       6,     7,     8,     9,    10,   823,    17,   129,     3,   210,
       3,   124,   213,   280,    20,    21,    22,    23,    24,    25,
      26,    27,    28,   117,    13,   372,    17,    38,    17,    16,
      17,     6,     7,     8,     9,    10,    31,    33,    17,    13,
     253,    36,    38,    17,    39,    20,    21,    22,    23,    24,
      25,    26,    27,    28,   241,   242,     5,   875,    32,    33,
      34,    35,    61,    13,    59,    60,    13,    62,    90,   163,
      17,    17,   397,   210,    69,   398,   213,    13,   255,   115,
     257,    17,    17,    33,   287,    17,   411,   255,    38,    18,
     251,   416,   254,    97,    89,    84,   299,   172,   173,   251,
     918,     6,     7,     8,     9,    10,   258,   258,   783,   312,
     313,   314,   315,   256,   109,    20,    21,    22,    23,    24,
      25,    26,    27,    28,   256,   255,     3,   163,   395,   251,
       3,    17,   399,   456,   918,    17,   403,   257,   405,   957,
     958,   959,   409,   410,   230,   231,   469,   251,    84,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   153,   362,
     363,   364,   365,   732,   251,    61,   251,    38,   197,   747,
      13,   494,    15,    16,   958,   959,   443,   444,   207,   208,
      66,   384,     3,   296,   251,   298,   252,   300,   301,    27,
      28,   257,    88,   460,    75,   462,    77,    13,    69,    70,
     467,    16,    17,    18,   255,    11,   257,    13,    14,     3,
      16,    17,    18,   249,   250,   538,   257,   103,   114,    25,
      26,     3,    28,    97,    30,   257,   175,   176,   177,   178,
     179,   180,   181,   182,    75,    11,    77,    13,    14,     3,
      16,    17,    18,     3,    13,   194,   195,   196,    17,    25,
      26,   257,    28,     3,    30,   630,     3,    63,   253,   255,
     176,   177,   251,    32,    33,    34,    35,     3,    17,    18,
       3,    66,   539,   185,   186,   222,   223,   251,   253,   567,
     605,   152,   567,     3,   119,    20,   572,    63,   197,    38,
     613,    95,    96,    97,    28,   143,   144,   246,   247,   147,
     135,   151,   627,   151,   251,    11,   141,    13,    14,   251,
      16,    17,    18,   148,   149,   251,    16,    17,    18,    25,
      26,   814,    28,   151,    30,   131,   132,   201,   237,   238,
     239,   240,   655,   600,   601,   710,   142,   143,   144,   225,
     226,   147,   609,   217,   611,   256,   257,   614,   256,   257,
     255,   251,   619,   251,   621,   131,   132,    63,   752,   753,
     754,   564,    71,    72,    73,   255,   142,   143,   144,    78,
      79,   147,    81,   866,   867,   868,   869,     6,     7,     8,
       9,    10,   256,   650,    10,    11,    12,   654,    39,   251,
     737,    20,    21,    22,    23,    24,    25,    26,    27,    28,
     251,    52,    53,    54,   199,    56,   308,   309,    59,    60,
     252,   253,    63,    64,   702,   255,    67,    68,   793,    39,
      17,   216,   255,   218,    61,   131,   132,   253,   253,   224,
      18,   255,   201,   808,    54,   191,   142,   143,   144,    59,
      60,   147,   174,    63,    64,   251,   252,    67,    68,   187,
     296,   255,   298,   259,   300,   301,    92,   156,   262,   263,
     264,   265,    82,   501,   502,   503,    55,   734,   159,    55,
       6,     7,     8,     9,    10,   251,   157,   253,   165,   169,
     185,   189,   251,   259,    20,    21,    22,    23,    24,    25,
      26,    27,    28,   171,   697,   698,   699,     6,     7,     8,
       9,    10,    17,   255,   255,   708,     6,     7,     8,     9,
      10,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    44,
     253,   798,   253,    59,   256,   117,   118,   119,   120,   121,
     253,   123,   124,   125,   126,   251,    18,    55,    63,    72,
      55,    80,    81,   259,   255,   253,   253,    80,    81,   255,
     255,   255,   887,    59,   889,   253,    55,    96,   771,    98,
      99,   253,   775,   776,   253,    55,   253,   780,   101,   102,
     103,   104,   253,    18,   253,   852,   853,   854,   876,   856,
     253,     3,     3,     3,   861,   110,   111,   112,   113,   114,
     115,   116,     3,    58,     3,   256,     3,     3,   933,    64,
       3,   253,   127,   253,    69,   130,    71,   820,    73,   822,
      75,   888,    77,   251,   253,    12,    26,    13,   895,   896,
       6,     7,     8,     9,    10,    25,   256,    28,    13,    24,
      55,    55,   253,   253,    20,    21,    22,    23,    24,    25,
      26,    27,    28,   117,   118,   119,   120,   121,   983,   123,
     124,   125,   126,   192,    44,   932,   156,   934,   935,   936,
     252,   938,   939,    55,   877,   878,   943,   880,     6,     7,
       8,     9,    10,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    20,    21,    22,    23,    24,    25,    26,    27,
      28,   163,    55,   991,    55,   166,   973,   253,   975,     6,
       7,     8,     9,    10,    61,   253,   253,   253,   985,   248,
     255,    17,    39,    20,    21,    22,    23,    24,    25,    26,
      27,    28,   253,   253,   253,   253,    74,   253,     3,   253,
     253,   256,    59,    60,   253,    17,    63,    64,    17,   253,
      67,    68,   253,   253,     6,     7,     8,     9,    10,   253,
     963,   964,   965,     6,     7,     8,     9,    10,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    20,    21,    22,
      23,    24,    25,    26,    27,    28,     6,     7,     8,     9,
      10,    17,   255,    18,   253,     6,     7,     8,     9,    10,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    20,
      21,    22,    23,    24,    25,    26,    27,    28,     6,     7,
       8,     9,    10,   253,   253,   252,   257,     6,     7,     8,
       9,    10,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    20,    21,    22,    23,    24,    25,    26,    27,    28,
       6,     7,     8,     9,    10,    17,    24,    16,    13,    13,
      14,    26,    16,    17,    20,    21,    22,    23,    24,    25,
      26,    27,    28,   251,   257,   219,   252,     6,     7,     8,
       9,    10,    44,   253,   253,   253,   253,   253,   253,   253,
      44,    20,    21,    22,    23,    24,    25,    26,    27,    28,
     255,    63,    39,   253,   253,   253,     3,   253,   253,    63,
     253,   228,   229,   255,     5,   256,    39,   253,   253,   253,
      13,     3,    59,    60,   252,   256,    63,    64,     3,     3,
      67,    68,   257,   253,   257,   253,    59,    60,   253,   256,
      63,    64,   253,    66,    67,    68,   253,   253,   110,   111,
     112,   113,   114,   115,   116,   252,   110,   111,   112,   113,
     114,   115,   116,   253,   253,   127,   253,    39,   130,    52,
     255,    18,    20,   127,    57,   129,   130,   251,   256,    13,
     253,   252,    65,   253,    75,   253,   253,    59,    60,   253,
      20,    63,    64,   256,    66,    67,    68,   257,   253,   253,
     252,   171,    74,   253,   253,   252,   252,    90,   253,   252,
      39,   253,    70,   129,    72,   254,    74,   254,    76,   251,
      78,    93,    94,    81,    82,   256,   253,   251,   251,   171,
      59,    60,   252,   255,    63,    64,   207,   221,    67,    68,
     253,   252,   133,   134,   253,   136,   137,   138,   139,   140,
     256,    74,   253,   253,   253,   253,   193,   494,   681,   170,
      88,   198,   711,   200,   252,   666,   685,   747,   490,    98,
     260,    94,   293,   252,    74,   543,   991,   957,   702,   572,
     103,   880,   694,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   778,   255,    94,   821,   252,   251,    -1,    -1,
      -1,    39,   256,   194,   195,   196,    44,    -1,    -1,   192,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,
      -1,    59,    60,   252,    -1,    63,    64,    -1,    -1,    67,
      68,    -1,    -1,   256,    -1,    -1,    74,    -1,    76,   211,
      -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,   232,
     173,    -1,    -1,    -1,    -1,   246,   247,    -1,    -1,    -1,
      98,   233,   234,   235,   236,   248,    -1,    -1,   106,   107,
      -1,   243,    -1,   173,    -1,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   256,    -1,   209,    -1,   211,   212,
      -1,    -1,   215,    -1,    -1,    17,    -1,   220,    -1,   137,
      -1,     3,   202,   203,   204,    -1,   206,    -1,    -1,    -1,
      -1,   211,    -1,    -1,    16,    17,   154,   155,    -1,   157,
     158,    -1,   160,   161,   162,    -1,   164,   256,    -1,   167,
     168,    -1,   170,   256,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   183,   184,    -1,    -1,    -1,
     188,    -1,   190,    39,    -1,    -1,   256,    59,    -1,    -1,
      62,    -1,    -1,    -1,    50,    51,    68,    69,    -1,    -1,
      -1,    -1,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    20,    21,    22,    23,
      24,    25,    26,    27,    28,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,    -1,    -1,    -1,    -1,    95,
      -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,   256,   105,
     106,   107,   108,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    -1,    -1,    -1,
     152,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   128
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   262,   263,    39,    50,    51,    95,   100,   105,
     106,   107,   108,   278,   279,   280,   316,   317,   318,   320,
     321,   322,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   336,   337,   338,   339,   414,   415,   416,   417,   418,
     434,   436,     0,     3,    31,    36,    39,    59,    60,    62,
      69,    89,   109,   153,   253,   265,   273,   282,   284,   287,
     289,   292,   293,   298,   304,   305,   341,   343,   353,   383,
     384,   385,   386,   419,   420,   421,   422,   430,   431,   435,
     437,   438,   439,    17,    18,    38,   340,    18,    49,   281,
       3,    80,    81,    96,    98,    99,   192,   248,    72,    80,
      81,   101,   102,   103,   104,    13,    33,    38,   334,   340,
     340,   340,    17,    18,    37,    48,   274,    80,    86,    17,
      61,    17,    90,    17,    11,    13,    14,    16,    17,    18,
      25,    26,    28,    30,    63,   131,   132,   142,   143,   144,
     147,   251,   259,   358,   362,   367,   370,   371,   372,   374,
     376,    17,   294,   294,    52,    57,    65,    90,   192,   227,
     232,   248,   294,    39,    59,    60,    63,    64,    66,    67,
      68,   256,   295,   307,   294,    44,    74,    76,    98,   106,
     107,   137,   154,   155,   157,   158,   160,   161,   162,   164,
     167,   168,   170,   183,   184,   188,   190,   256,   295,   294,
     193,   198,   200,   256,   295,   387,   388,   389,   294,   228,
     229,   256,   295,   294,    66,    74,    93,    94,   211,   233,
     234,   235,   236,   243,   256,   295,   311,   313,   314,   294,
      98,   256,   295,   432,   433,    52,    53,    54,    56,   256,
     283,   286,   295,    54,    82,   256,   285,   295,    33,    38,
     255,   308,   281,     3,    17,    38,   319,     3,    97,     3,
     323,   319,    66,   103,   225,   226,   319,   319,     3,     3,
       3,     3,     3,     3,     3,    13,   335,     3,     3,     3,
      20,    38,   255,   275,   308,    13,    17,   251,   264,    13,
      15,    16,   288,   342,   290,   354,    13,    17,    27,   251,
     258,   366,   368,   374,    28,   251,   151,   151,    13,   258,
     369,   376,   251,   251,   251,   251,   376,    13,    14,   251,
     357,   358,   359,   360,   361,   362,   363,   364,     5,    75,
     133,   134,   136,   137,   138,   139,   140,   175,   176,   177,
     178,   179,   180,   181,   182,   194,   195,   196,   246,   247,
     375,   440,     6,     7,     8,     9,    10,    20,    21,    22,
      23,    24,    25,    26,    27,    28,   255,   255,   255,   308,
      17,   297,    61,   264,    32,    33,    34,    35,   264,   266,
     306,    38,    69,    70,   152,   296,   350,   296,   253,   253,
     255,   172,   173,    18,   266,   191,   174,   187,    92,   156,
      16,    17,   267,    55,   159,    55,   264,   157,   165,   176,
     177,   169,   171,   185,   186,   185,   189,   266,   253,   255,
     288,   266,   264,   253,   390,   256,   255,    59,   230,   231,
     253,   255,   428,   429,    18,   264,   255,    70,   241,   242,
     423,   264,   264,    55,    55,   155,   244,   245,   253,   253,
     255,   255,   267,   268,   253,   115,   163,   249,   250,   253,
      59,   266,    55,   266,   253,   253,   253,    55,    18,   272,
     253,   253,    71,    72,    73,    78,    79,    81,   309,   310,
       3,     3,   319,     3,     3,     3,    38,    59,    62,    68,
      69,    82,    83,    84,    85,    87,   268,   324,   350,     3,
     319,   319,   319,   319,     3,     3,     3,    16,   264,    39,
      40,    41,    42,    43,    44,    45,    46,    47,   276,   277,
     253,   376,   253,   117,   118,   119,   120,   121,   123,   124,
     125,   126,   344,   345,   346,   348,   352,    91,    92,    93,
     253,   291,   251,   351,   368,   368,   376,   368,   368,    12,
      13,   376,   380,   381,    25,    26,   369,   369,    28,   376,
     376,   376,   376,   252,   257,    13,    24,   257,   260,    25,
      26,   255,   257,   260,   376,   376,   376,   376,   376,   376,
     376,   376,   376,   119,   135,   141,   148,   149,   376,   376,
     376,   376,   288,   299,   302,   303,    17,   348,   349,   376,
      55,    55,   253,   253,   264,    44,   266,   267,   264,   156,
     264,    55,   264,   163,    55,   166,   264,   264,   266,    55,
     253,    61,   253,   266,   253,   255,    66,   199,   216,   218,
     224,   391,   396,   399,    17,   253,   253,   303,   253,   253,
     312,   313,   253,   253,   253,   264,   264,   253,   253,   253,
      61,    88,   114,   315,    28,   254,   270,    18,   267,   264,
     264,   264,   267,   268,   269,   256,   257,     3,    17,    17,
     349,   269,    17,    18,   413,   413,   413,   413,   253,   253,
     256,   257,   252,    17,   122,   253,   255,   267,   264,   252,
     345,   347,   352,   252,   257,   252,   252,   257,   257,   257,
     376,   257,    24,    16,   360,    13,    16,   363,   251,    26,
     301,   257,   264,   264,   253,   266,   253,   253,   253,   264,
     253,   264,   253,   267,   264,   253,   253,   253,   253,   264,
     264,   253,   409,   412,   201,   266,   255,   219,   268,   392,
     393,   253,   255,   253,   255,   427,   256,   253,   253,   253,
     264,    75,    77,    75,    77,   256,   264,   267,   310,     3,
       3,     3,     3,   277,   346,    17,    44,    63,   110,   111,
     112,   113,   114,   115,   116,   127,   130,   355,   372,   373,
     377,   382,   252,   253,   380,   376,   376,   376,   252,    13,
     359,   257,   376,    18,   268,   300,   302,   253,   257,   253,
     253,   253,   253,   253,   253,   253,   303,   264,   401,   288,
     255,   397,   426,   312,   253,    18,   271,   271,   271,   271,
      20,   251,    20,   251,   376,   376,   376,   256,   375,   440,
     253,   376,   378,   379,   355,   345,   252,   252,   252,   252,
      13,   252,   268,   264,   255,   411,   256,   268,   402,   403,
     404,   394,   173,   202,   203,   204,   206,   211,   256,   311,
     398,   169,   229,   256,   425,   315,   253,   253,   253,   253,
     376,   381,   376,   372,   253,   128,   255,    20,    20,    24,
     257,   253,   256,   253,   410,   217,   253,    97,   201,   217,
     256,   395,   264,   264,   264,   171,    84,   264,    70,   210,
     213,   253,   264,   197,   237,   238,   239,   240,   424,   253,
     315,   315,   315,   315,   253,   252,   253,   440,   255,   356,
     382,   129,   360,   365,   376,   376,   143,   144,   147,   151,
     379,   103,   173,   199,   201,   202,   203,   204,   205,   206,
     209,   211,   212,   215,   220,   256,   311,   400,   253,   266,
     264,   266,   253,   264,   264,   252,   355,   129,   254,   254,
     256,   253,   253,   251,   251,   251,   253,   255,   264,   266,
     264,   264,   264,   171,   264,    84,   264,   197,   207,   208,
      70,   210,   213,   207,   264,   221,   253,   253,   256,   356,
     355,   355,   376,   376,   376,   405,   264,   264,   266,   222,
     223,   264,   365,   252,   252,   252,    16,   256,   406,   407,
     408,   253,   253,   253,   214,   253,   253
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 293 "cf-parse.y"
    { return 0; ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 294 "cf-parse.y"
    { return 0; ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 307 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 308 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 312 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 316 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 325 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 326 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 327 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 328 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 329 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 330 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 337 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 344 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 352 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 356 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 360 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 367 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 375 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 376 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 382 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 391 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 396 "cf-parse.y"
    { (yyval.g) = NULL; ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 397 "cf-parse.y"
    { (yyval.g) = stderr; ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 401 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 402 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 406 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 407 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 411 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 412 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 413 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 414 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 415 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 416 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 417 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 418 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 419 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 427 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (3)].t), RECONFIG_HARD); ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 430 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (4)].t), RECONFIG_SOFT); ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 433 "cf-parse.y"
    { cli_msg(7, "Shutdown requested"); order_shutdown(); ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 436 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 445 "cf-parse.y"
    {
#ifndef CONFIG_MULTIPLE_TABLES
     if (cf_krt)
       cf_error("Kernel protocol already defined");
#endif
     cf_krt = this_proto = proto_config_new(&proto_unix_kernel, sizeof(struct krt_config));
     this_proto->preference = DEF_PREF_INHERITED;
     THIS_KRT->scan_time = 60;
     THIS_KRT->learn = THIS_KRT->persist = 0;
     krt_scan_construct(THIS_KRT);
     krt_set_construct(THIS_KRT);
   ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 461 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 462 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 466 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 478 "cf-parse.y"
    {
     if (cf_kif)
       cf_error("Kernel device protocol already defined");
     cf_kif = this_proto = proto_config_new(&proto_unix_iface, sizeof(struct kif_config));
     this_proto->preference = DEF_PREF_DIRECT;
     THIS_KIF->scan_time = 60;
     init_list(&THIS_KIF->primary);
     krt_if_construct(THIS_KIF);
   ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 491 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 495 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 508 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->scan.table_id = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 520 "cf-parse.y"
    {
   new_config->router_id = (yyvsp[(3) - (4)].i32);
   ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 526 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 528 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   ;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 547 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 548 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 549 "cf-parse.y"
    { new_config->listen_bgp_flags |= SKF_V6ONLY; ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 556 "cf-parse.y"
    {
   rt_new_table((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 568 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = SYM_PROTO;
     s->def = this_proto;
     this_proto->name = s->name;
     ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 574 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), SYM_PROTO, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 582 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 586 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 587 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 588 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 589 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 590 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 591 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 595 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 597 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 598 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 602 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 610 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 611 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 617 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 625 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 626 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 627 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 631 "cf-parse.y"
    { this_ipn->positive = 1; ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 632 "cf-parse.y"
    { this_ipn->positive = 0; ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 649 "cf-parse.y"
    {
     struct rt_dev_config *p = proto_config_new(&proto_device, sizeof(struct rt_dev_config));
     this_proto = &p->c;
     p->c.preference = DEF_PREF_DIRECT;
     init_list(&p->iface_list);
   ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 664 "cf-parse.y"
    {
     struct rt_dev_config *p = (void *) this_proto;
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&p->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 679 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 680 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 681 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 686 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 690 "cf-parse.y"
    { (yyval.i) = D_STATES; ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 691 "cf-parse.y"
    { (yyval.i) = D_ROUTES; ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 692 "cf-parse.y"
    { (yyval.i) = D_FILTERS; ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 693 "cf-parse.y"
    { (yyval.i) = D_IFACES; ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 694 "cf-parse.y"
    { (yyval.i) = D_EVENTS; ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 695 "cf-parse.y"
    { (yyval.i) = D_PACKETS; ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 716 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 734 "cf-parse.y"
    { ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 735 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 736 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 737 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 738 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 739 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 748 "cf-parse.y"
    { cmd_show_status(); ;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 751 "cf-parse.y"
    { proto_show((yyvsp[(3) - (4)].s), 0); ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 754 "cf-parse.y"
    { proto_show((yyvsp[(4) - (5)].s), 1); ;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 758 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 762 "cf-parse.y"
    { if_show(); ;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 765 "cf-parse.y"
    { if_show_summary(); ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 768 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 771 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->table = config->master_rtc->table;
   ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 777 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 783 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 790 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 795 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 800 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   ;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 805 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 809 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 813 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 823 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 831 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 835 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 842 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 843 "cf-parse.y"
    { (yyval.i) = 2; ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 847 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].s)); ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 851 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 853 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 855 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); ;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 857 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 859 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 861 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 863 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 865 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 871 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 872 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 877 "cf-parse.y"
    { (yyval.i) = 4096; ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 878 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   ;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 885 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), 0); ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 887 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), 1); ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 889 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), 2); ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 893 "cf-parse.y"
    { proto_debug((yyvsp[(2) - (4)].t), (yyvsp[(3) - (4)].i)); ;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 897 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].s)->name; ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 898 "cf-parse.y"
    { (yyval.t) = "*"; ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 905 "cf-parse.y"
    { cf_push_scope( (yyvsp[(2) - (2)].s) ); ;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 905 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s) = cf_define_symbol((yyvsp[(2) - (4)].s), SYM_FILTER, (yyvsp[(4) - (4)].f));
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 914 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); ;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 918 "cf-parse.y"
    { (yyval.i) = T_INT; ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 919 "cf-parse.y"
    { (yyval.i) = T_BOOL; ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 920 "cf-parse.y"
    { (yyval.i) = T_IP; ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 921 "cf-parse.y"
    { (yyval.i) = T_PREFIX; ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 922 "cf-parse.y"
    { (yyval.i) = T_PAIR; ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 923 "cf-parse.y"
    { (yyval.i) = T_STRING; ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 924 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 925 "cf-parse.y"
    { (yyval.i) = T_PATH; ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 926 "cf-parse.y"
    { (yyval.i) = T_CLIST; ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 927 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_IP:
	  case T_PAIR:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   ;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 946 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 957 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 958 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 965 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 966 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 973 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 982 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 990 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1014 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1015 "cf-parse.y"
    { (yyval.s)=NULL; ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1019 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1025 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1028 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1038 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1039 "cf-parse.y"
    {
     if ((yyvsp[(1) - (2)].x)) {
       if ((yyvsp[(1) - (2)].x)->next)
	 bug("Command has next already set");
       (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x);
       (yyval.x) = (yyvsp[(1) - (2)].x);
     } else (yyval.x) = (yyvsp[(2) - (2)].x);
   ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1050 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1053 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1062 "cf-parse.y"
    { (yyval.i) = make_pair((yyvsp[(2) - (5)].i), (yyvsp[(4) - (5)].i)); ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1069 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1073 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1074 "cf-parse.y"
    { (yyval.v).type = T_PAIR; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1075 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1076 "cf-parse.y"
    {  (yyval.v).type = (yyvsp[(1) - (1)].i) >> 16; (yyval.v).val.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1080 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (1)].v); 
	(yyval.e)->to = (yyvsp[(1) - (1)].v);
   ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1085 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (4)].v); 
	(yyval.e)->to = (yyvsp[(4) - (4)].v); 
   ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1093 "cf-parse.y"
    { (yyval.e) = (yyvsp[(1) - (1)].e); ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1094 "cf-parse.y"
    { (yyval.e) = (yyvsp[(3) - (3)].e); (yyval.e)->left = (yyvsp[(1) - (3)].e); ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1098 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1105 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1106 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1107 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1108 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1115 "cf-parse.y"
    { (yyval.trie) = f_new_trie(); trie_add_prefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1116 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_prefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); ;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1119 "cf-parse.y"
    { (yyval.e) = NULL; ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1120 "cf-parse.y"
    {
     (yyval.e) = (yyvsp[(1) - (4)].e);
     (yyval.e)->data = (yyvsp[(3) - (4)].x);
     (yyval.e)->left = (yyvsp[(4) - (4)].e);
   ;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1125 "cf-parse.y"
    {
     (yyval.e) = f_new_tree(); 
     (yyval.e)->from.type = T_VOID; 
     (yyval.e)->to.type = T_VOID;
     (yyval.e)->data = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1136 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1137 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1141 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1142 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1146 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1147 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1148 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; ;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1149 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1150 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1154 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1155 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1156 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1160 "cf-parse.y"
    {
        if (((yyvsp[(2) - (5)].x)->code == 'c') && ((yyvsp[(4) - (5)].x)->code == 'c'))
          { 
            if (((yyvsp[(2) - (5)].x)->aux != T_INT) || ((yyvsp[(4) - (5)].x)->aux != T_INT))
              cf_error( "Can't operate with value of non-integer type in pair constructor" );
            (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PAIR;  (yyval.x)->a2.i = make_pair((yyvsp[(2) - (5)].x)->a2.i, (yyvsp[(4) - (5)].x)->a2.i);
          }
	else
	  { (yyval.x) = f_new_inst(); (yyval.x)->code = P('m', 'p'); (yyval.x)->a1.p = (yyvsp[(2) - (5)].x); (yyval.x)->a2.p = (yyvsp[(4) - (5)].x); }
    ;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1173 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1174 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1175 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  ;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1176 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1177 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1178 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1179 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); ;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1180 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); ;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1181 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1182 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; ;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1196 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1219 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   ;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1252 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; ;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1254 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; ;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1255 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ ;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1256 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ ;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1257 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); ;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1258 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; ;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1259 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); ;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1260 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest); ;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1264 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1265 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1266 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1267 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1268 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1269 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1270 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1271 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1272 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1273 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1274 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1275 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1276 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1277 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1278 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); ;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1279 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1281 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1282 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1283 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1285 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; ;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1287 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; ;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1289 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); ;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1291 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; ;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1292 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1293 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1294 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1295 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1305 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; ;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1306 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; ;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1307 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1308 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; ;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1309 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; ;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1314 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1337 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; ;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1338 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; ;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1339 "cf-parse.y"
    { (yyval.i) = F_REJECT; ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1340 "cf-parse.y"
    { (yyval.i) = F_ERROR; ;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1341 "cf-parse.y"
    { (yyval.i) = F_NOP; ;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1342 "cf-parse.y"
    { (yyval.i) = F_NONL; ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1346 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1349 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1350 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1351 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1360 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   ;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1367 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1376 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1377 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1381 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   ;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1387 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   ;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 1397 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1406 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   ;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 1412 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 1417 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 1424 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 1429 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   ;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 1435 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); ;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 1436 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); ;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 1437 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 1446 "cf-parse.y"
    { struct f_inst *i = f_new_inst(); i->code = 'E'; i->aux = T_CLIST; (yyval.x) = (yyvsp[(2) - (5)].x); (yyval.x)->code = P('e','S'); (yyval.x)->a1.p = i; ;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 1447 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 1448 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 1449 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 1455 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config));
     this_proto->preference = DEF_PREF_BGP;
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_as4 = bgp_as4_support;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
 ;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 1475 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); ;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 1476 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip)) cf_error("Only one neighbor per BGP instance is allowed");

     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     BGP_CFG->remote_as = (yyvsp[(5) - (6)].i);
   ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 1482 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i); ;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 1483 "cf-parse.y"
    { BGP_CFG->rr_client = 1; ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 1484 "cf-parse.y"
    { BGP_CFG->rs_client = 1; ;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 1485 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 1486 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 1487 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 1488 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 1489 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (6)].i); BGP_CFG->multihop_via = (yyvsp[(5) - (6)].a); ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 1490 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; ;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 1491 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); ;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 1492 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 1493 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 1494 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 1495 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 1496 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 1497 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); ;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 1498 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 1499 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 1500 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 1501 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 1502 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 1503 "cf-parse.y"
    { BGP_CFG->route_limit = (yyvsp[(4) - (5)].i); ;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 1504 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 1513 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config));
     this_proto->preference = DEF_PREF_OSPF;
     init_list(&OSPF_CFG->area_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 1529 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 1530 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i) ; if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 1534 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (3)].i32);
  this_area->stub = 0;
  init_list(&this_area->patt_list);
  init_list(&this_area->vlink_list);
  init_list(&this_area->net_list);
  init_list(&this_area->stubnet_list);
 ;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 1555 "cf-parse.y"
    { this_area->stub = (yyvsp[(3) - (3)].i) ; if((yyvsp[(3) - (3)].i)<=0) cf_error("Stub cost must be greater than zero"); ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 1556 "cf-parse.y"
    {if((yyvsp[(2) - (2)].i)) { if(!this_area->stub) this_area->stub=DEFAULT_STUB_COST;}else{ this_area->stub=0;};}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 1569 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 1583 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); ;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 1584 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 1585 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); ;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 1589 "cf-parse.y"
    { finish_iface_config(OSPF_PATT); ;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 1599 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 1600 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 1601 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 1602 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 1603 "cf-parse.y"
    { OSPF_PATT->dead = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 1604 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 1605 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 1606 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 1607 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 1612 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->dead = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 1633 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 1634 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 1635 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 1636 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 1637 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 1638 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); ;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 1639 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 1640 "cf-parse.y"
    { OSPF_PATT->dead = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 1641 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 1642 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 1643 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 1644 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 1645 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; ;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 1646 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 1648 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 1649 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 1650 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 1651 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; ;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 1652 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; ;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 1653 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) cf_error("Buffer size is too small") ; ;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 1667 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (2)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (2)].px).len;
 ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 1676 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (3)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (3)].px).len;
   this_pref->hidden = 1;
 ;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 1695 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (2)].a);
   this_nbma->eligible=0;
 ;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 1704 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=1;
 ;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 1714 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->dead = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->strictnbma = 0;
  OSPF_PATT->stub = 0;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 1747 "cf-parse.y"
    { finish_iface_config(OSPF_PATT); ;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 1752 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 1757 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); ;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 1760 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 1763 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 1766 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0); ;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 1769 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1); ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 1774 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config));
     this_proto->preference = DEF_PREF_PIPE;
     PIPE_CFG->mode = PIPE_OPAQUE;
  ;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 1784 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   ;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 1789 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 1790 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; ;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 1796 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config));
     rip_init_config(RIP_CFG);
   ;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 1805 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); ;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 1806 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); ;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 1807 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); ;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 1808 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 1809 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 1810 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); ;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 1812 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; ;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 1813 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; ;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 1814 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; ;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 1819 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; ;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 1820 "cf-parse.y"
    { (yyval.i)=AT_MD5; ;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 1821 "cf-parse.y"
    { (yyval.i)=AT_NONE; ;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 1826 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; ;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 1827 "cf-parse.y"
    { (yyval.i)=0; ;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 1828 "cf-parse.y"
    { (yyval.i)=IM_QUIET; ;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 1829 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; ;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 1830 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; ;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 1834 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 1835 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); ;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 1849 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   ;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 1865 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config));
     static_init_config((struct static_config *) this_proto);
  ;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 1877 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&((struct static_config *) this_proto)->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  ;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 1886 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (3)].a);
   ;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 1890 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&((struct static_config *) this_proto)->iface_routes, &this_srt->n);
   ;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 1896 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; ;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 1897 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; ;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 1898 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; ;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 1902 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); ;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 1910 "cf-parse.y"
    { bgp_check(BGP_CFG); ;}
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 1910 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); ;}
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 1913 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 1914 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); ;}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 1915 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); ;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 1916 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); ;}
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 1917 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); ;}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 1918 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); ;}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 1919 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); ;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 1920 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); ;}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 1921 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); ;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 1921 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); ;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 1921 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); ;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 1921 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); ;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 1921 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); ;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 1921 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); ;}
    break;



/* Line 1455 of yacc.c  */
#line 6301 "cf-parse.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1923 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


